import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;

class TableMemoire extends AbstractTableModel {
	private int taille=50;
	final String[] columnNames = {"Addr","Contenu"};
	final Object[][] data= new String[taille][2];

	public TableMemoire() {
		super();
		for(int i=0;i<50;i++)
			data[i][0]=Integer.toString(i); //pour numroter
	}

        public String getColumnName(int col) {
            return columnNames[col];
        }

	public int getRowCount() {
		return taille;
	}

	public int getColumnCount() {
		return(2);
	}
	
	public Object getValueAt(int l, int c) {
		return((Object)data[l][c]);
	}

	public void setValueAt(Object valeur, int l, int c) {
		//System.out.println(valeur+" "+l);
		data[l][c]=valeur;
		fireTableDataChanged();
	}

	public boolean isCellEditable( int l, int c) {
		return true;
	}
}
	
public class Memoire extends JFrame {
	private JTable laMemoire;
	TableMemoire model;

	public Memoire() {
		setTitle("la Mmoire");
		setSize(150,400);
		setLocation(580,20);
		
		model=new TableMemoire();
		laMemoire= new JTable(model);				
		laMemoire.getColumnModel().getColumn(0).setPreferredWidth(12);
		Container c=getContentPane();
		c.add(new JScrollPane(laMemoire),"Center");
		show();
	}

	public String getCase(int l) {
		laMemoire.setRowSelectionInterval(l,l);
		model.fireTableDataChanged();
		//repaint();
		//requestFocusInWindow();
		return((String)laMemoire.getValueAt(l,1));
	}

	public void setCase(int l,int valeur) {
		laMemoire.setValueAt(Integer.toString(valeur),l,1);
		//repaint();
	}
	
	static public void main(String[] args)
	{
		//a titre de test
		Memoire test=new Memoire();
		test.getCase(3);
		for(int i=0;i<16854251;i++) ;
		test.getCase(5);
		for(int i=0;i<16854251;i++) ;
		test.getCase(1);
	}
}
