import javax.swing.*;
import java.awt.*;

public class RegistresControle extends JPanel {
	Registre compteurOrdinal;
	Registre decodeur;
	Registre etats;
	Registre accumulateur;
	
	public RegistresControle() {
		super();
		setLayout(new GridLayout(5,2));		
		compteurOrdinal=new Registre('R');
		compteurOrdinal.setText("0");
		decodeur=new Registre('R');
		etats=new Registre('R');
		accumulateur=new Registre('B');
		setLayout(new GridLayout(5,2));
		add(new JLabel("Compteur Ordinal"));
		add(compteurOrdinal);
		add(new JLabel("Dcodeur"));
		add(decodeur);
		add(new JLabel());
		add(new JLabel());
		add(new JLabel("<html><B>Accumulateur</B>"));
		add(accumulateur);
		add(new JLabel("Registre d'tat"));
		add(etats);
	}	

	public void setCO(int adresse) {
		compteurOrdinal.modifie(Integer.toString(adresse));
	}

	public int getCO() {
		return(Integer.parseInt(compteurOrdinal.getText()));
	}

	public void setA(int valeur) {
		accumulateur.modifie(valeur);
	}

	public int getA() {
		return(Integer.parseInt(accumulateur.getText()));
	}
	
	public void clearEtats() {
		etats.raz();
	}
	public void setEtat(String motif) {	
		//on ajoute le nouveau motif aux eventuels existants
		etats.modifie(motif+"-"+etats.getText());
	}
	
	public boolean isZ() {
		if(etats.getText().indexOf("Z")>0)
			return(true);
		else
			return(false);
	}
	
	public boolean isN() {
		if(etats.getText().indexOf("N")>0)
			return(true);
		else
			return(false);
	}

	public boolean isD() {
		if(etats.getText().indexOf("D")>0)
			return(true);
		else
			return(false);
	}


	public void transfert(String laCommande) {
		decodeur.modifie(laCommande);
	}

	public void raz() {
		System.out.println("raz et 0 dans CO");
		compteurOrdinal.setText("0");
		decodeur.raz();
		etats.raz();
		accumulateur.raz();
	}
}

