import javax.swing.*;
import java.awt.*;

public class Registre extends JTextField {

	private int temporisation; //variable vitesse d'affichage
	private char couleur; // Couleur de l'objet en action (R V ou B)

	public Registre(int tempo,char coul) {
		super(10);
		temporisation=tempo;
		couleur=coul;
	} 
	//ici, les diffrentes surcharges...
	public Registre(char coul) {	
		this(2,coul);
	}	
	public Registre(int tempo) {	
		this(tempo,'V');
	}	

	public Registre() {	
		this(2);
	}	


	public void modifie(String leTexte) {
		/*cette mthode permet la modification du contenu
		* avec un petit effet graphique (variation de couleur)*/
		super.setText(leTexte);
		setBackground(Color.red);
		for(int i=0;i<256;i+=temporisation) {
			long temps=System.currentTimeMillis();
			while (System.currentTimeMillis() < temps + 1) ;
			
			switch(couleur) { //diffrentes couleurs...
				case 'R' :
					setBackground(new Color(255,i,i));
					break;
				case 'V' :
					setBackground(new Color(i,255,i));
					break;
				case 'B' :
					setBackground(new Color(i,i,255));
					break;
			}
			update(getGraphics()); //a amliorer, mais sinon 
						//pas de mise  jour...
		}
	}

	public 	void modifie(int laValeur) {
		/*petite surcharge, me permet de grer le dcodeur comme un
		* autre registre...*/
		modifie(Integer.toString(laValeur));
	}

	public void raz() {
		//si on a besoin de nettoyer, discretement, sans effet...	
		setText("");
		update(getGraphics());
	}

}

